
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
  var temSender;
  var MNBigbangClass = JSB.defineClass(
    'MNBigband : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.clickDate = Date.now()
        self.watchMode = false;
        self.isFirst = true;

        // Application.sharedInstance().showHUD(self.addonController.appearOnNewExcerpt,self.window,2)

        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          try {
            
          self.addonController = bigbangController.new();
          self.addonController.mainPath = mainPath;
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          // try {
          //   self.appInstance.studyController(self.window).view.sendSubviewToBack(self.addonController.view)
            
          // } catch (error) {
          //   Application.sharedInstance().showHUD(error,self.window,2)
            
          // }
          self.addonController.view.hidden = true;
          self.addonController.notebookid = notebookid
          self.notebookid = notebookid

          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClose:', 'closeBigbang');

          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');
            self.addonController.view.frame = { x: 50, y: 100, width: 400, height: 290 }
            self.addonController.currentFrame = { x: 50, y: 100, width: 400, height: 290 }
          } catch (error) {
            Application.sharedInstance().showHUD(error,self.window,2)
          }
          }
          if (dynamic !== undefined) {
            self.addonController.dynamic = dynamic
          }
          self.customLayoutAddonController();
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
          
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        // self.addonController.homePage()
        self.watchMode = false;
        self.textSelected = '';
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnNote');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'closeBigbang');

        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            let height = studyFrame.height-10;
            let splitLine = getSplitLine()
            switch (self.addonController.customMode) {
              case "left":
                self.addonController.view.frame = { x: 40, y: 10, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.addonController.view.frame = { x: splitLine + 5, y: 10, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.addonController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 10, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: self.watchMode
          };
        } else {
          return null;
        }
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
          //  Application.sharedInstance().showHUD(sender.userInfo.winRect, self.window, 2);

        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        isOnSelection = true
        self.textSelected = encodeURIComponent(sender.userInfo.documentController.selectionText.replaceAll('/', '\\/'));
        self.addonController.selectedText = self.textSelected
        if (self.isNewWindow) {
          self.newWindowController.selectedText = self.textSelected
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.imageModeButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);

          if (self.isNewWindow) {
            self.newWindowController.imageModeButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.imageModeButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (self.isNewWindow) {
              self.newWindowController.imageModeButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        //watch mode

        // var text = sender.userInfo.documentController.selectionText;
        if (self.textSelected && self.textSelected.length) {
          self.addonController.search(self.textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
        }
      },
      onProcessNewExcerpt:function (sender) {
        // Application.sharedInstance().showHUD("color: ",self.window,5)
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        if (note.excerptPic) {
          note.fillIndex = self.addonController.imagePattern[note.colorIndex]
        }else{
          note.fillIndex = self.addonController.textPattern[note.colorIndex]
        }
        Application.sharedInstance().refreshAfterDBChanged(self.notebookid)

        // if (self.addonController.processNewExcerptColor !== -1 && note.colorIndex !== self.addonController.processNewExcerptColor) {
        //   return
        // }
        // if (self.addonController.appearOnNewExcerpt && self.textSelected && self.textSelected.length) {
        //   self.addonController.shouldCopy = self.addonController.autoCopy
        //   self.addonController.shouldComment = self.addonController.autoComment
        //   self.addonController.currentNoteId = sender.userInfo.noteid
        //   self.addonController.search(self.textSelected);
        //   if (self.addonController.autoDynamic) {
        //     self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
        //   }
        //   self.addonController.view.hidden = false;
        // }
        // // self.layoutAddonController(temSender)
        // // if (watchMode) {
        // //   self.addonController.view.hidden = true
        // // }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        if (!self.watchMode || !self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5)
        let currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        // Application.sharedInstance().showHUD(note,self.window,2)
        if (note.excerptText) {
          let string = note.excerptText
          // self.addonController.clear()
          self.addonController.currentNoteid = note.noteId
          let colors = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
          let backgroundColor = "#ffffff"
          self.addonController.wordButtonColor = "#ffffff"
          let theme = self.appInstance.currentTheme
          if (theme === "Gray") {
            colors = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
            backgroundColor = "#626262"
            self.addonController.wordButtonColor = "#e0e0e0"
          }else if (theme === "Dark") {
            colors = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
            backgroundColor = "#212121"
            self.addonController.wordButtonColor = "#e0e0e0"
          }
          self.addonController.view.layer.borderColor = UIColor.colorWithHexString(colors[note.colorIndex]).colorWithAlphaComponent(0.8)
          self.addonController.view.backgroundColor = UIColor.colorWithHexString(backgroundColor).colorWithAlphaComponent(0.8)
          self.addonController.moveButton.backgroundColor = UIColor.colorWithHexString(colors[note.colorIndex]).colorWithAlphaComponent(0.8)
          self.addonController.closeButton.backgroundColor = UIColor.colorWithHexString(colors[note.colorIndex]).colorWithAlphaComponent(0.8)
          // self.addonController.heading.backgroundColor = UIColor.colorWithHexString(colors[note.colorIndex]).colorWithAlphaComponent(0.8)
          self.addonController.setButtonText(string)
          self.addonController.view.hidden = false;
        }
      },
      onClose:function (sender) {
        // Application.sharedInstance().showHUD("color: ",self.window,5)
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        self.watchMode = false
        self.appInstance.studyController(self.window).refreshAddonCommands();
      },
      toggleAddon:function (sender) {
        if (Date.now()-self.clickDate < 500) {
          self.appInstance.showHUD("Watch mode", self.window, 2);
          self.watchMode = true
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.addonController.view.hidden = false
          return
        }
        try {

        self.clickDate = Date.now()
        self.watchMode = false
        self.appInstance.studyController(self.window).refreshAddonCommands();
          // self.appInstance.showHUD(self.addonController.scrollview.hidden, self.window, 2);
        
        let string = "这些变化在其他降雨数据中也可以识别出来"
        let focusNote = self.appInstance.studyController(self.window).notebookController.focusNote
        if (!focusNote) {
          self.appInstance.showHUD("No note selected", self.window, 2);
          return
        }
        if (focusNote.excerptText) {
          string = focusNote.excerptText
        }
        if (self.addonController.view.hidden) {
          // self.addonController.clear()
          if (self.isFirst) {
            let buttonFrame = sender.superview.superview.frame
            let width = self.appInstance.osType !== 1 ? 400 : 365
            if (buttonFrame.x === 0) {
              self.addonController.view.frame = {x:40,y:buttonFrame.y,width:width,height:400}
            }else{
              self.addonController.view.frame = {x:buttonFrame.x-width,y:buttonFrame.y,width:width,height:400}
            }
            self.addonController.currentFrame = self.addonController.view.frame
            self.isFirst = false;
          }
          self.addonController.currentNoteid = focusNote.noteId
          let colors = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
          let backgroundColor = "#ffffff"
          self.addonController.wordButtonColor = "#ffffff"
          let theme = self.appInstance.currentTheme
          if (theme === "Gray") {
            colors = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
            backgroundColor = "#626262"
            self.addonController.wordButtonColor = "#e0e0e0"
          }else if (theme === "Dark") {
            colors = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
            backgroundColor = "#212121"
            self.addonController.wordButtonColor = "#e0e0e0"
          }
          self.addonController.view.layer.borderColor = UIColor.colorWithHexString(colors[focusNote.colorIndex]).colorWithAlphaComponent(0.8)
          self.addonController.view.backgroundColor = UIColor.colorWithHexString(backgroundColor).colorWithAlphaComponent(0.8)
          self.addonController.moveButton.backgroundColor = UIColor.colorWithHexString(colors[focusNote.colorIndex]).colorWithAlphaComponent(0.8)
          self.addonController.closeButton.backgroundColor = UIColor.colorWithHexString(colors[focusNote.colorIndex]).colorWithAlphaComponent(0.8)
          // self.addonController.heading.backgroundColor = UIColor.colorWithHexString(colors[focusNote.colorIndex]).colorWithAlphaComponent(0.8)

          self.addonController.setButtonText(string)
        }
        if (self.addonController.view.hidden) {
          self.addonController.show()
        }else{
          self.addonController.hide()
        }
        } catch (error) {
          self.appInstance.showHUD(error,self.window,2)
        }
      }
      
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNBigbangClass.prototype.layoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 :500, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNBigbangClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 : 500, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  return MNBigbangClass;
};